;Blitz3D source code.

Graphics3D 800,600,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Const gravity#=.1

Global died=0
Global levelwon=0
Global lives=4
Global frozen=0
Global loops
Global gametext$
Global gamewait
Global level=1


Global lifeimage=LoadImage("image\life.bmp")
MaskImage lifeimage,255,0,255


Type Fps
	Field fps,frames
	Field time
End Type
Global fps.fps=New fps


Type Guy
	Field x#,y#,z#
	Field speedx#,speedy#
	Field move#
	Field size#
	Field angle#
	
	Field frame#
	Field ent
End Type

Type PartSpot
	Field x#,y#,z#
	Field life
	Field size#
End Type

Type Part
	Field ent
	Field speedx#,speedy#,speedz#
	Field life
	Field size#
End Type
Global partent
partent=CreateSprite()
ScaleSprite partent,2,2
parttex=LoadTexture("image\blood.bmp",4)
EntityTexture partent,parttex
HideEntity partent


Type World
	Field sizex,sizey
End Type
Global world.world=New world
worldmake()


Global music=LoadSound("sound\moosic.wav")
LoopSound music
Global musicch=PlaySound(music)

Global eatsound=LoadSound("sound\eat2.wav")
Global diesound=LoadSound("sound\die.wav")
Global levelwonsound=LoadSound("sound\levelwon.wav")

Dim sprite(8,8)
spritesload()



Global guyam
Local guy.guy
guy=New guy
guy\x=0
guy\y=0
guy\frame=1

Global you.guy
you=guy

Global camera=CreateCamera()
TurnEntity camera,-20,0,0
MoveEntity camera,0,-70,-400


gametext="Level "+level
gamewait=100

yousizeset()

font1=LoadFont("arial",14)
font2=LoadFont("arial",35)
SetFont font1

timer=CreateTimer(60)
Repeat
	loops=loops+1
	guysupdate()
	partsupdate()
	WaitTimer timer
	fpsupdate()
	
	
	If died=1 Then
		If First part=Null Then
			died=0
			gamereset()
		EndIf
	EndIf

	RenderWorld
	
	For f=1 To lives-1
		DrawImage lifeimage,(f-1)*25+1,1
	Next
	
	If gamewait>0 Then
		gamewait=gamewait-1
		SetFont font2
		Text 400,300,gametext,1,1
		If gamewait=0 Then
			SetFont font1
			If levelwon=2 Then levelwon=0
			If levelwon=1 Then
				level=level+1
				gametext="Level "+level
				gamewait=100
				yousizeset()
				levelwon=2
			EndIf
		EndIf
	Else
		Text GraphicsWidth()-60,1,"level "+level
		If you\size>111 Then
			gametext="You win!"
			gamewait=100
			levelwon=1
			PlaySound levelwonsound
		EndIf
	EndIf
	
	Flip
	Cls
	
	If KeyHit(1) Then End
	;If KeyHit(57) Then frozen=1
	MoveEntity camera,0,0,MouseZSpeed()*22
Forever



Function GuyKill(guy.guy)
	Local part.part
	Local am
	Local size2#
	
	size2=1+guy\size/8
	
	Local spot.partspot
	spot=New partspot
	spot\x=guy\x
	spot\y=guy\y
	spot\z=guy\z
	spot\size=size2
	spot\life=7+guy\size/10
	Return
	
	am=3+guy\size/10
	If guy=you Then am=am*5
	For f=1 To am
		part=partmake(size2)
		PositionEntity part\ent,guy\x,guy\y,guy\z+5
	Next
End Function



Function PartMake.part(size)
	Local part.part
	
	part=New part
	part\ent=CopyEntity(partent)
	part\size=Rnd(1,2)*size
	ScaleSprite part\ent,part\size,part\size
	SpriteViewMode part\ent,2
	part\speedz=-2
	angle=Rnd(360)
	part\speedx=Cos(angle)*Rnd(1.5)
	part\speedy=Sin(angle)*Rnd(1.5)
	part\life=30
	
	Return part
End Function



Function PartsUpdate()
	Local part.part
	Local spot.partspot
	
	For spot=Each partspot
		spot\life=spot\life-1
		part=partmake(spot\size)
		PositionEntity part\ent,spot\x,spot\y,spot\z
		If spot\life<=0 Then Delete spot
	Next


	
	For part=Each part
		part\speedz=part\speedz+gravity
		part\life=part\life-1
		part\size=part\size-.1
		
		TranslateEntity part\ent,part\speedx,part\speedy,part\speedz
		;PositionEntity part\ent,EntityX(part\ent),EntityY(part\ent),(EntityY(part\ent)+world\sizey)/(world\sizey*2)-10
		TurnEntity part\ent,0,0,10
		
		If part\life<=0 Then
			FreeEntity part\ent
			Delete part
		EndIf
	Next
	
End Function



Function SpritesLoad()
	For dir=1 To 8
		For frame=1 To 8
			texture=LoadTexture("image\cow\move "+dir+","+frame+".bmp",1+8+4)
			entity=CreateSprite()
			EntityTexture entity,texture
			HideEntity entity
			sprite(dir,frame)=entity
			SpriteViewMode entity,2
			ScaleSprite entity,16,16
		Next
		Text 0,0,"%done "+frame/8.0*100
		Flip
		Cls
	Next
	
End Function


Function WorldMake()
	world\sizex=400
	world\sizey=300

	fencetex=LoadTexture("image\fence.bmp",4)
	ScaleTexture fencetex,1,.1
	
	For go=-1 To +1 Step 2
		fence=CreateCube()
		PositionEntity fence,world\sizex*go,0,5
		ScaleEntity fence,1,world\sizey,20
		EntityTexture fence,fencetex
	Next
	
	fencetex2=LoadTexture("image\fence.bmp",4)
	ScaleTexture fencetex2,.1,1
	For go=-1 To +1 Step 2
		fence=CreateCube()
		PositionEntity fence,0,world\sizey*go,-1
		ScaleEntity fence,world\sizex,1,20
		EntityTexture fence,fencetex2
	Next
	
	
	ground=CreatePlane()
	groundtex=LoadTexture("image\grass.bmp")
	EntityTexture ground,groundtex
	ScaleTexture groundtex,60,60
	TurnEntity ground,-90,0,0
End Function


Function YouSizeSet()
	you\size=9+30/(level+1)
End Function


Function FPSUpdate()
	fps\frames=fps\frames+1
	If MilliSecs()-fps\time>=1000 Then
		fps\time=MilliSecs()
		fps\fps=fps\frames
		fps\frames=0
	EndIf
End Function


Function GuyMake.guy()
	Local guy.guy
	
	guy=New guy
	guy\frame=1
	
	If Rand(0,1)=0 Then
		guy\x=Rnd(-world\sizex,world\sizex)
		guy\y=world\sizey
		If Rand(0,1) Then guy\y=-guy\y
	Else
		guy\x=world\sizex
		guy\y=Rnd(-world\sizey,world\sizey)
		If Rand(0,1) Then guy\x=-guy\x
	EndIf
	
	;angle=angleto(guy\x,guy\y,you\x,you\y)
	angle=angleto(guy\x,guy\y,0,0)
	angle=angle+Rnd(-45,45)
;	angle2=angle/45*45
;	If Abs(angledif(angle,angle2))>5 Then angle=angle2
	guy\angle=angle
	
	guy\size=Rnd(5,36+level)
	If guy\size<6 Then guy\size=6
	;If Rnd(100)<55 Then guy\size=Rnd(5,10)
	guy\move=.5
	
	guyam=guyam+1
	
	Return guy
End Function



Function GuysUpdate()
	Local guy.guy
	
	If died=1 Then Return
	
	If Rnd(100)<4+loops/700.0+level/1.5 And guyam<40 And frozen=0 And gamewait=0 Then
		guymake()
	EndIf
	
	For guy=Each guy
		If guy<>you And frozen=1 Then Exit
		
		guy\move=.15+guy\size/200
		If guy=you Then
			guy\move=guy\move+.24
		Else
			guy\move=guy\move*4
			guy\move=guy\move+level/2.7
			
			guy\speedx=Cos(guy\angle)*guy\move
			guy\speedy=Sin(guy\angle)*guy\move
		EndIf
		
	
		guy\x=guy\x+guy\speedx
		guy\y=guy\y+guy\speedy
		guy\z=(guy\y+world\sizey)/(world\sizey*2)-11
		
		;sprite
		FreeEntity guy\ent
		guy\frame=guy\frame+(Abs(guy\speedx)+Abs(guy\speedy))/3.5
		If Floor(guy\frame)>8 Then guy\frame=1
		dir=dir8get(guy\speedx,-guy\speedy)
		guy\ent=CopyEntity(sprite(dir,Floor(guy\frame)))
		ScaleSprite guy\ent,guy\size*2,guy\size*2
		PositionEntity guy\ent,guy\x,guy\y,guy\z

		If guy=you Then
			If gamewait>0 And levelwon=0 Then
				EntityAlpha guy\ent,.65+Cos(loops*20)*.3
			EndIf
		EndIf
		
		If guy=you Then
			guy\speedx=guy\speedx+(KeyDown(205)-KeyDown(203))*guy\move
			guy\speedy=guy\speedy-(KeyDown(208)-KeyDown(200))*guy\move
			guy\speedx=curveto(guy\speedx,0,6)
			guy\speedy=curveto(guy\speedy,0,6)
			
			If guy\x<-world\sizex Then guy\x=-world\sizex
			If guy\y<-world\sizey Then guy\y=-world\sizey
			If guy\x>+world\sizex Then guy\x=+world\sizex
			If guy\y>+world\sizey Then guy\y=+world\sizey
		Else
			    If guy\x<-world\sizex Then: guyreset guy
			ElseIf guy\y<-world\sizey Then: guyreset guy
			ElseIf guy\x>world\sizex Then: guyreset guy
			ElseIf guy\y>world\sizey Then: guyreset guy
			EndIf
		EndIf
		
	Next


	If gamewait>0 And levelwon=0 Then
		;no collision
	Else
		guyscollision()
	EndIf
	
End Function



Function GuysCollision()
	Local guy2.guy
	Local guy.guy
	
	For guy=Each guy
		For guy2=Each guy
			If guy=guy2 Then Exit
			If GuysCollide(guy,guy2) Then
;			If RectsOverlap(guy\x-guy\size,guy\y-guy\size,guy\size*2,guy\size*2,guy2\x-guy2\size,guy2\y-guy2\size,guy2\size*2,guy2\size*2) Then
				If guy\size<guy2\size Then
					If frozen Then EntityAlpha guy\ent,Rnd(1):Exit
					If guy2=you Then PlaySound eatsound
					guy2\size=guy2\size+guy\size/5
					guyreset guy
					Exit
				Else
					If frozen Then EntityAlpha guy\ent,Rnd(1):Exit
					If guy=you Then PlaySound eatsound
					guy\size=guy\size+guy2\size/5
					guyreset guy2
				EndIf
			EndIf
		Next
	Next

End Function


Function GuysCollide(guy.guy,guy2.guy)
	Local go,go2
	Local angle
	Local factor#=.9
	
	For go=-1 To 1 Step 2
		angle=ATan2(guy\speedy,guy\speedx)
		newx=guy\x+Cos(angle)*(guy\size*factor)*go
		newy=guy\y+Sin(angle)*(guy\size*factor)*go
		For go2=-1 To 1 Step 2
			angle=ATan2(guy2\speedy,guy2\speedx)
			newx2=guy2\x+Cos(angle)*guy2\size*factor*go2
			newy2=guy2\y+Sin(angle)*guy2\size*factor*go2
;			If circlescollide(newx,newy,guy\size*1, newx2,newy2,guy2\size*1) Then
			If RectsOverlap(newx-guy\size/2,newy-guy\size/2,guy\size,guy\size, newx2-guy2\size/2,newy2-guy2\size/2,guy2\size,guy2\size) Then
;			If RectsOverlap(guy\x-guy\size,guy\y-guy\size,guy\size*2,guy\size*2,guy2\x-guy2\size,guy2\y-guy2\size,guy2\size*2,guy2\size*2) Then
				Return 1
			EndIf
		Next
	Next
	
	Return 0
End Function

Function GuyReset(guy.guy)
	guykill(guy)
	If guy=you Then
		died=1
		guy\x=99999
		PositionEntity guy\ent,guy\x,guy\y,guy\z
		PlaySound diesound
		Return
	EndIf
	guyam=guyam-1
	FreeEntity guy\ent
	Delete guy
End Function


Function GameReset()
	Local guy.guy
	
	For guy=Each guy
		If guy<>you Then
			guyreset guy
		EndIf
	Next
	If guyam<>0 Then RuntimeError "guyam="+guyam
	
	yousizeset()
	you\x=0
	you\y=0
	
	StopChannel(musicch)
	musicch=PlaySound(music)
	
	loops=0
	
	lives=lives-1
	
	If lives<=0 Then
		gametext="Game Over...  Restart from level 1"
		gamewait=120
		level=1
		lives=4
	Else
		gametext="Try again!"
		gamewait=100
	EndIf
	
End Function


Function CurveTo#(num#,dest#,speed#)
	If num<dest Then
		Return num+Abs(dest-num)/speed
	ElseIf num>dest Then
		Return num-Abs(dest-num)/speed
	EndIf
	Return num
End Function



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;the angle from x1,y1 pointing to x2,y2
;returns 0-359
Function AngleTo%(x1#,y1#,x2#,y2#)
	Local angle
	
	angle=ATan2(y2-y1,x2-x1)
	If angle<0 Then
		Return angle+360
	Else
		Return angle
	EndIf
End Function



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;angle difference
;how far away two angles are, assuming they can skip over the end of anglemax to get to 0
Function AngleDif#(anglenow#,angletar#,anglemax=360)
	Local temp#

	temp#=angletar-anglenow
	If temp>+anglemax/2 Then Return temp-anglemax
	If temp<-anglemax/2 Then Return temp+anglemax
	Return temp
End Function


;returns a number from 1 to 8
Function Dir8Get(speedx#,speedy#)
	angle=ATan2(speedy,speedx)
	;225 270 315
	;180     000
	;135 090 045
	;
	;5 6 7
	;4   8
	;3 2 1
	;
	;8 at 360-45/2 to 45/2
	;1 at 45/2 to 45*3/2
	If angle<0 Then angle=angle+360
	angle=Int(angle/45.0)
	If angle=0 Then angle=8
	Return angle
End Function

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function CirclesCollide(cx,cy,cr,c2x,c2y,c2r)
	Local distx,disty
	
	If RectsOverlap(cx-cr,cy-cr,cr*2,cr*2,c2x-c2r,c2y-c2r,c2r*2,c2r*2)=0 Then Return 0
	distx=Abs(cx-c2x)
	disty=Abs(cy-c2y)
	Return (distx*distx+disty*disty)<(cr+cr2)*(cr+cr2)
End Function